#include "extern.h"

/* ##BEG## 9/24/91, SHU */
Node *check_DirectiveStmt (root)
Node *root;
{
        Node *sublist, *sub, *temp, *sub1, *temp1, *sub2, *temp2;
        T_Entry *entry, *entry1;
        char *name;
        int isDecomp=0, isDist=0, num, i,len;
        Etype *etype;
        

        /* eventually, we need to check each dimension size and keep
                that information for decomposition statements.  Also,
                when within a subroutine, we need more check to see
                if it is a formal parameter or common data, or local */
        if (root->DirectiveStmt.Dirdecompose != 0)  {
            sublist = root->DirectiveStmt.DecomposeList;
            isDecomp = 1;
            }
        else if (root->DirectiveStmt.Dirdistribute != 0) {
            sublist = root->DirectiveStmt.DistributeList;
            isDist = 1;
            }
        else if (root->DirectiveStmt.Diralign != 0) {
            return(check_align(root));
            }
        else 
            sublist = 0;
    
        for (LIST_LOOP (sub, sublist, temp)) {
            name = sub->DecomposeSpec.Name->com.str;
            if ((entry = lookup_loc (name)) != TN
                && entry->typ->shape != (Shape*) 0) {  /* is array */
                if (isDist) {
                    if (!IS_decomposed(entry)) {
                        sprintf(serr,"array '%s' has not been decomposed",name);
                        fatal (serr);
                        }
                    else if (entry->dist != 0) {
                        sprintf(serr,"array '%s' has been distributed",name);
                        fatal (serr);
                        }
                    else {
                        entry1=install_loc(name,TAB_DIST,sub);
      /* I did not used list_invert since if (block, block) both block same so list invert
         assume both of them are LIST_FIRST */
                   len = tree_list_len(sub->DistributeSpec.DistList); len--;
                   for(LIST_LOOP(sub2, sub->DistributeSpec.DistList, temp2))
                       {
                          entry1->dist_style[len]=0;
                      if(sub2->DistList.type == DIRBLOCK)
                          entry1->dist_style[len]=1; 
                      if(sub2->DistList.type == DIRCYCLIC)
                          entry1->dist_style[len]=2; 
                      len--;


                    }

                        
                        }
                    }
              }

/* This part of routine if it finds a decompose statement it put that name in symbol table
   and dummy set type of that entry and set rank of that decomposition                */
            if (isDecomp) {                       /*  ZEKI */
                    if ((entry = lookup_loc (name)) ==TN){
                            entry = install_loc (name, TAB_NAME, 0);
                            etype = implicit_get_for_external (name);
                            install_loc (name, TAB_TYP_ETYPE, etype);
                            num = 0;
                            for (LIST_LOOP (sub1,sub->DecomposeSpec.SizeList, temp1))
                                    num++;
                            entry->typ->shape=shape_malloc();
                            entry->typ->shape->rank = num;
                            zb_template_rank=num; /** BOZKUS **/

                            SET_decomposed(entry);
                          }
                    else {
                        sprintf(serr,"array '%s' has  been decomposed or defined before",name);
                        fatal (serr);
                        }
                  }
                    check_array_rank (sub->DecomposeSpec.SizeList, name); 
          }
        return(root);
}

check_array_rank (list, name)
Node *list;
char *name;
{
        Node *sub, *temp;
        int num, decnum;
        T_Entry *entry;

        num = 0;
        for (LIST_LOOP (sub, list, temp))
                num++;

        entry = lookup_loc (name);

        if (num != (decnum = entry->typ->shape->rank)) {
                sprintf (serr, "array '%s' needs %d subscript%s, got %d"
                , name, decnum, error_s (decnum), num);
                fatal (serr);
        }
}

/* ##END## */


/* ##BEG## 10/28/91, ZEKI */

Node *check_align (root)
Node *root;
{
  Node *sublist, *sub, *temp;
  T_Entry *entry, *entryfordist;
  char *name, *name_template;
 
  sublist = root->DirectiveStmt.AlignList;
  for (LIST_LOOP (sub, sublist, temp)) {
      name = sub->AlignSpec.Name->com.str;
      if ((entry = lookup_loc (name)) != TN
             && entry->typ->shape != (Shape*) 0) {  /* is array */
                 if (IS_aligned(entry)) {
                     sprintf(serr,"array '%s' was aligned before",name);
                     fatal (serr);
                   }
                   else {
                   name_template = root->DirectiveStmt.AlignSpec->AlignSpec.Name->com.str;
                          if ((entryfordist = lookup_loc( name_template)) != TN
                               && entryfordist->typ->shape != (Shape*)0
                               && entryfordist->dist !=NN) {
                              entry->align_template = entryfordist;

   entry->indexlist = sub->AlignSpec.SubscriptList;
   entry->template_indexlist = root->DirectiveStmt.AlignSpec->AlignSpec.SubscriptList;

                              SET_aligned(entry);
                              find_local_shape(entry);
                           }
                           else {
 sprintf(serr,"distribute template '%s' has not been distributed",entryfordist->name);
                                   fatal (serr);
                                }
                        }
           /*     else {
                       sprintf(serr,"array '%s' has not been declared",name);
                       fatal (serr);
                     }
           */
               }
    }
  return(root);
}

/* ##END## */
